import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:get/get.dart';
import 'package:making_school_asignment_app/common/job/user_info_detail.dart';
import 'package:making_school_asignment_app/common/store/app_storage_key.dart';
import 'package:making_school_asignment_app/common/store/user_store.dart';
import 'package:making_school_asignment_app/common/utils/storage.dart';
import 'package:making_school_asignment_app/page/global_widget/my_text.dart';
import 'package:making_school_asignment_app/routes/app_pages.dart';

class MyInfo extends StatefulWidget {
  const MyInfo({super.key});

  @override
  State<MyInfo> createState() => _MyInfoState();
}

class _MyInfoState extends State<MyInfo> with AutomaticKeepAliveClientMixin {
  late Rx<UserInfoDetail?> userInfo = UserStore.to.userDetailInfo;

  // 确认对话框
  _showAlertDialog(context1) async {
    await showDialog(
        // 表示点击灰色背景的时候是否消失弹出框
        barrierDismissible: false,
        context: context1,
        builder: (context) {
          return AlertDialog(
              title: quickText("提示信息"),
              content: quickText("您确定要退出登录吗?"),
              actions: <Widget>[
                TextButton(
                  child: quickText("取消"),
                  onPressed: () {
                    Navigator.pop(context, 'Cancle');
                  },
                ),
                TextButton(
                    child: quickText("确定"),
                    onPressed: () async {
                      try {
                        UserStore.to.erase();
                        await StorageService.to.erase();
                        StorageService.to
                            .write(AppStorageKey.privacyAgreement.value, true);
                        Navigator.pop(context, "Ok");
                        Get.offAllNamed(Routes.login);
                      } catch (e) {
                        print(e);
                      }
                    })
              ]);
        });
  }

  @override
  bool get wantKeepAlive => true;

  @override
  Widget build(BuildContext context) {
    super.build(context);

    final personalInfoTitleStly = TextStyle(
      color: const Color.fromRGBO(80, 87, 103, 1),
      fontSize: 13.sp,
    );
    final personalInfoValStly = TextStyle(
      color: const Color.fromRGBO(148, 163, 182, 1),
      fontSize: 13.sp,
    );

    return OrientationBuilder(
        builder: (BuildContext context, Orientation orientation) {
      return Stack(
        children: [
          SizedBox(
            height: double.infinity,
            child: Column(
              children: [
                Container(
                  height: 220.h,
                  width: double.infinity,
                  decoration: const BoxDecoration(
                    image: DecorationImage(
                      image: AssetImage('assets/images/personal_bgi.png'),
                      fit: BoxFit.cover,
                    ),
                  ),
                ),
                Expanded(
                    child: Container(
                  color: const Color.fromRGBO(248, 248, 248, 1),
                ))
              ],
            ),
          ),
          SafeArea(
            child: Scaffold(
              backgroundColor: Colors.transparent,
              body: Column(
                children: [
                  Stack(
                    alignment: const FractionalOffset(0.04, 0.1),
                    children: [
                      Container(
                        height: 180.h,
                        alignment: Alignment.center,
                        child: Column(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            SizedBox(
                              height: 10.r,
                            ),
                            Image.asset(
                              'assets/images/default_user_dead.png',
                            ),
                            SizedBox(
                              height: 10.r,
                            ),
                            InkWell(
                              onTap: () {
                                /*if (tokenState == '' || userState.id == '') {
                                    toLoginPage(context);
                                  }*/
                              },
                              child: Container(
                                margin: EdgeInsets.only(top: 0.h),
                                child: Text(
                                  userInfo.value?.name ?? '请前往登录',
                                  style: TextStyle(
                                      fontSize: 13.sp, color: Colors.white),
                                ),
                              ),
                            ),
                          ],
                        ),
                      ),
                      /* InkWell(
                          onTap: () => Get.back(),
                          child: Icon(Icons.arrow_back_ios_new_rounded, color: Colors.white, size: 24.sp),
                        ),*/
                    ],
                  ),
                  SizedBox(height: 14.h),
                  Container(
                    margin:
                        EdgeInsets.symmetric(vertical: 22.h, horizontal: 16.w),
                    padding:
                        EdgeInsets.symmetric(vertical: 22.h, horizontal: 16.w),
                    height: 180.h,
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.all(Radius.circular(6.w)),
                      color: Colors.white,
                      boxShadow: const [
                        BoxShadow(
                          color: Color.fromRGBO(46, 91, 255, 0.1),
                          offset: Offset.zero, //阴影y轴偏移量
                          blurRadius: 20, //阴影模糊程度
                          spreadRadius: 10, //阴影扩散程度
                        )
                      ],
                    ),
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: [
                        Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Text('账号', style: personalInfoTitleStly),
                            Text(userInfo.value?.name ?? '请前往登录',
                                style: personalInfoValStly)
                          ],
                        ),
                        Container(
                          height: 1.w,
                          color: const Color.fromRGBO(240, 243, 255, 1),
                        ),
                        Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Text('所在学校', style: personalInfoTitleStly),
                            Text(userInfo.value?.schoolName ?? '',
                                style: personalInfoValStly)
                          ],
                        ),
                        /* Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Text('担任职位', style: personalInfoTitleStly),
                            SizedBox(width: 20.w),
                            Expanded(
                              child: Text(
                                userInfo.value?.gender??'',
                                maxLines: 2,
                                textAlign: TextAlign.right,
                                overflow: TextOverflow.ellipsis,
                                style: personalInfoValStly,
                              ),
                            )
                          ],
                        ),
 Container(height: 1.w, color: const Color.fromRGBO(240, 243, 255, 1)),
                          Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: [
                              Text('所授科目', style: personalInfoTitleStly),
                              Expanded(
                                child: Text(
                                  userState.subjectIds.map((e) => getSubjectEnumName(e)).toList().join(','),
                                  maxLines: 2,
                                  textAlign: TextAlign.right,
                                  overflow: TextOverflow.ellipsis,
                                  style: personalInfoValStly,
                                ),
                              )
                            ],
                          ),*/
                        Container(
                            height: 1.w,
                            color: const Color.fromRGBO(240, 243, 255, 1)),
                        Padding(
                          padding: EdgeInsets.only(top: 10.h),
                          child: InkWell(
                            onTap: () {
                              Get.toNamed(Routes.otherPage);
                            },
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                Text('其他', style: personalInfoTitleStly),
                                Icon(
                                  Icons.arrow_forward_ios,
                                  color: const Color.fromRGBO(80, 87, 103, 1),
                                  size: 13.sp,
                                )
                              ],
                            ),
                          ),
                        )
                      ],
                    ),
                  ),
                  Expanded(
                    child: Column(
                      children: [
                        const Expanded(child: SizedBox()),
                        Container(
                          margin: EdgeInsets.only(bottom: 40.h),
                          alignment: Alignment.bottomCenter,
                          child: InkWell(
                            child: Container(
                              padding: EdgeInsets.symmetric(vertical: 14.h),
                              margin: EdgeInsets.only(right: 16.w, left: 16.w),
                              decoration: BoxDecoration(
                                borderRadius: BorderRadius.all(
                                  Radius.circular(6.w),
                                ),
                                color: Colors.white,
                                boxShadow: [
                                  BoxShadow(
                                    color:
                                        const Color.fromRGBO(46, 91, 255, 0.2),
                                    offset: Offset(2.w, 2.h), //阴影y轴偏移量
                                    blurRadius: 14, //阴影模糊程度
                                    spreadRadius: 0.5, //阴影扩散程度
                                  )
                                ],
                              ),
                              child: Row(
                                crossAxisAlignment: CrossAxisAlignment.center,
                                mainAxisAlignment: MainAxisAlignment.center,
                                children: [
                                  Icon(
                                    Icons.exit_to_app_outlined,
                                    size: 13.sp,
                                    color:
                                        const Color.fromRGBO(148, 163, 182, 1),
                                  ),
                                  Container(
                                    width: 6.w,
                                  ),
                                  Text(
                                    '退出登录',
                                    style: TextStyle(
                                        color: const Color.fromRGBO(
                                            148, 163, 182, 1),
                                        fontSize: 13.sp),
                                  ),
                                ],
                              ),
                            ),
                            onTap: () {
                              _showAlertDialog(context);
                            },
                          ),
                        ),
                      ],
                    ),
                  ),
                ],
              ),
            ),
          ),
        ],
      );
    });
  }
}
